% Text Mining with MATLAB 2nd Edition
% www.http://www.textmininglab.net/

% CHAPTER 4: Basic Operations with Strings

clear
disp('Example 4.1 ------------------------------------------------------');
disp('THIS EXAMPLE IS NOT A MATLAB SCRIPT')                          %(4.1)
pause;

disp('Example 4.2 ------------------------------------------------------');
text_string = "This is SECTION 4.1";                                 %(4.2)
pause;

disp('Example 4.3 ------------------------------------------------------');
indexes = strfind(text_string,'is')                                 %(4.3a)
nmatch = length(indexes)                                            %(4.3b)
pause;

disp('Example 4.4 ------------------------------------------------------');
patt = digitsPattern                                                %(4.4a)
indexes = strfind(text_string,patt)                                 %(4.4b)
nmatch = length(indexes)                                            %(4.4c)
pause;

disp('Example 4.5 ------------------------------------------------------');
indexes = strfind(text_string,'example')                            %(4.5a)
nmatch = length(indexes)                                            %(4.5b)
pause;

disp('Example 4.6 ------------------------------------------------------');
content = ["this is line one","and line two","and three"]           %(4.6a)
indexes = strfind(content,'ne')                                     %(4.6b)
indexes{1}                                                          %(4.6c)
indexes{2}                                                          %(4.6d)
indexes{3}                                                          %(4.6e)
pause;

disp('Example 4.7 ------------------------------------------------------');
contains(content,'ne') % checks for pattern occurrences             %(4.7a)
count(content,'ne') % counts pattern occurreneces                   %(4.7b)
pause;

disp('Example 4.8 ------------------------------------------------------');
occurrences = eq(char(text_string),'T')                             %(4.8a)
% uses an alternative syntax for the equal relational operator      %(4.8b)
occurrences = char(text_string) == 'T'
pause;

disp('Example 4.9 ------------------------------------------------------');
nmatch = sum(occurrences)                                            %(4.9)
pause;

disp('Example 4.10 -----------------------------------------------------');
indexes = find(occurrences)                                         %(4.10)
pause;

disp('Example 4.11 -----------------------------------------------------');
disp(text_string)                                                  %(4.11a)
indexes = find( char(text_string)>='A' & char(text_string)<='Z' )  %(4.11b)
pause;

disp('Example 4.12 -----------------------------------------------------');
disp('THIS EXAMPLE IS NOT A MATLAB SCRIPT')                         %(4.12)
pause;

disp('Example 4.13 -----------------------------------------------------');
content1 = "comparable"; content2 = "comparison";                  %(4.13a)
samestrings = strcmp(content1,content1)                            %(4.13b)
samestrings = strcmp(content1,content2)                            %(4.13c)
pause;

disp('Example 4.14 -----------------------------------------------------');
samestrings = content1 == content2 % compares strings              %(4.14a)
samechars = char(content1) == char(content2) % compares characters %(4.14b)
%samechars = char(content1) == 'compare'                           %(4.14c)
% uncomment and execute example (4.14c) to see the error message
pause;

disp('Example 4.15 -----------------------------------------------------');
content = ["txt","pdf","txt","jpeg","pdf","txt"];                  %(4.15a)
istxt = strcmp(content,'txt')                                      %(4.15b)
pause;

disp('Example 4.16 -----------------------------------------------------');
output = strcmp(content,["pdf","pdf","pdf","jpeg","jpeg","jpeg"])   %(4.16)
pause;

disp('Example 4.17 -----------------------------------------------------');
content == "txt"                                                   %(4.17a)
content == ["pdf","pdf","pdf","jpeg","jpeg","jpeg"]                %(4.17b)
pause;

disp('Example 4.18 -----------------------------------------------------');
s1 = "days"; s2 = "tray";                                          %(4.18a)
editDistance(s1,s2)                                                %(4.18b)
editDistance(s2,s1)                                                %(4.18c)
pause;

disp('Example 4.19 -----------------------------------------------------');
txt = 'Today''s 2nd winner is ticket number 638-775-321 !';        %(4.19a)
digit = (txt>='0')&(txt<='9');                                     %(4.19b)
s = txt; s(digit) = '#'                                        
alpha = ((txt>='A')&(txt<='Z')) | ((txt>='a')&(txt<='z'));         %(4.19c)
s = txt; s(not(digit|alpha)) = '*'
pause;

disp('Example 4.20 -----------------------------------------------------');
s = txt; s(not(digit|alpha)) = ''                                  %(4.20a)
%s = txt; s(not(digit|alpha)) = '<*>'                              %(4.20b)
% uncomment and execute example (4.20b) to see the error message
pause;

disp('Example 4.21 -----------------------------------------------------');
disp('THIS EXAMPLE IS NOT A MATLAB SCRIPT')                         %(4.21)
pause;

disp('Example 4.22 -----------------------------------------------------');
txtstr = "In 1994, 20% of investments produced 80% of revenues";   %(4.22a)
regexprep(txtstr,'\d+\%*','<NUM>')                                 %(4.22b)
pause;

disp('Example 4.23 -----------------------------------------------------');
charv = '<img width="250" height="300" src="image_location" />';   %(4.23a)
expression = '(<img.+?width=")(.+?)(".+?height=")(.+?)(".+?/>)';
regexprep(string(charv),expression,'$1$4$3$2$5')                   %(4.23b)
pause;

disp('Example 4.24 -----------------------------------------------------');
disp('THIS EXAMPLE IS NOT A MATLAB SCRIPT')                         %(4.24)
pause;

disp('Example 4.25 -----------------------------------------------------');
replace(txtstr,(digitsPattern+'%')|digitsPattern,'<NUM>')          %(4.25a)
replace(txtstr,'produced','generated')                             %(4.25b)
pause;

disp('Example 4.26 -----------------------------------------------------');
txtstr = ["next Monday","next Tuesday","last Friday"];             %(4.26a)
replace(txtstr,'next','last')                                      %(4.26b)
patt = ["Monday","Tuesday","Friday"];                              %(4.26c)
rplc = ["week","month","year"];
replace(txtstr,patt,rplc)
pause;

disp('Example 4.27 -----------------------------------------------------');
txtstr = " He'd said: ""I just don't care!!!"""                    %(4.27a)
split(txtstr)'                                                     %(4.27b)
pause;

disp('Example 4.28 -----------------------------------------------------');
% defining split locations with a string array of characters   %(4.28a)
split(txtstr,{':','!','"',' '})' 
% defining split locations with a pattern                      %(4.28b)
split(txtstr,alphanumericBoundary)'
pause;

disp('Example 4.29 -----------------------------------------------------');
patt = characterListPattern(':.,;"?!'); % defines the pattern      %(4.29a)
temp = erase(txtstr,patt) % removes non-word characters            
temp = strip(temp) % removes preceding and trailing whitespaces    %(4.29b)
split(temp)' % splits the input string into words                  %(4.29c)
pause;

disp('Example 4.30 -----------------------------------------------------');
disp('THIS EXAMPLE IS NOT A MATLAB SCRIPT')                         %(4.30)
pause;

disp('Example 4.31 -----------------------------------------------------');
[token,reminder] = strtok(txtstr,':.,;"?! ')                        %(4.31)
pause;

disp('Example 4.32 -----------------------------------------------------');
newstring = txtstr; index = 0;                                      %(4.32)
while 1
    [temp,newstring] = strtok(newstring,':.,;"?! ');
    if temp=="", break; end;
    index = index+1;
    tokens(index) = temp;
end;
tokens
pause;

disp('Example 4.33 -----------------------------------------------------');
% removes non-word characters, preceding and trailing whitespaces  %(4.33a)
patt = characterListPattern(':,.;"?!');
temp = strip(erase(txtstr,patt));
% replaces all whitespaces between words with the sequence ","     %(4.33b)
temp = replace(temp,' ','","')
% executes the command tokens=["..."] to create the string array   %(4.33c)
eval(['tokens=["',char(temp),'"]'])
pause;

disp('Example 4.34 -----------------------------------------------------');
data = ["This is"," an example ","on string concatenation"]        %(4.34a)
join(data) % joins strings with whitespaces                        %(4.34b)
join(data,'') % joins strings with the given token                 %(4.34c)
join(data,{' :','-> '}) % joins strings with different tokens      %(4.34d)
pause;

disp('Example 4.35 -----------------------------------------------------');
horcat = strcat(data{:})                                           %(4.35a)
vercat = strvcat(data{:})                                          %(4.35b)
whos horcat vercat                                                 %(4.35c)
pause;

disp('Example 4.36 -----------------------------------------------------');
bracket_horcat = [data{:}] % horizontal concatenation              %(4.36a)
char_vercat = char(data{:}) % vertical concatenation               %(4.36b)
pause;

disp('Example 4.37 -----------------------------------------------------');
newdata = string(vercat)                                           %(4.37a)
newdata = strip(newdata)' 
pause;

disp('Example 4.38 -----------------------------------------------------');
disp('THIS EXAMPLE IS NOT A MATLAB SCRIPT')                         %(4.38)
pause;

disp('Example 4.39 -----------------------------------------------------');
txtstr = sprintf("%s",data) % returns a string                     %(4.39a)
charv = sprintf('%s',data) % returns a character vector            %(4.39b)
whos txtstr charv                                                  %(4.39c)
pause;

disp('Example 4.40 -----------------------------------------------------');
sprintf("-> %s%s\n   %s!",data)                                     %(4.40)
pause;

disp('Example 4.41 -----------------------------------------------------');
data(1) + data(2) + data(3)                                         %(4.41)
pause;

disp('Example 4.42 -----------------------------------------------------');
join(tokens)                                                       %(4.42a)
strip(sprintf("%s ",tokens))                                       %(4.42b)
pause;

disp('Example 4.43 -----------------------------------------------------');
join([" ",tokens,"!!!"""],{'',' ',': "',' ',' ',' ',''})           %(4.43a)
sprintf(" %s %s: ""%s %s %s %s!!!""",tokens)                       %(4.43b)
pause;

disp('Example 4.44 -----------------------------------------------------');
s1 = "is this a test ?";                                           %(4.44a)
c1 = split(s1)';
s2 = "what a test !";                                              %(4.44b)
c2 = split(s2)';   
pause;

disp('Example 4.45 -----------------------------------------------------');
unique(char(s1))                                                   %(4.45a)
unique(char(s2))                                                   %(4.45b)
pause;

disp('Example 4.46 -----------------------------------------------------');
% gets the list of unique elements along with the indexes          %(4.46a)
[uniqueset,fwdidx,bwdidx] = unique(char(s1));
% maps the original string into the set of unique elements         %(4.46b)
s1{1}(fwdidx)
% maps back the set of unique elements into the original string    %(4.46c)
uniqueset(bwdidx)
pause;

disp('Example 4.47 -----------------------------------------------------');
union(char(s1),char(s2))                                           %(4.47a)
intersect(char(s1),char(s2))                                       %(4.47b)
setxor(char(s1),char(s2))                                          %(4.47c)
pause;

disp('Example 4.48 -----------------------------------------------------');
[un,id1,id2] = union(char(s1),char(s2));                           %(4.48a)
id1'
id2'
sort([s1{1}(id1),s2{1}(id2)])
[in,id1,id2] = intersect(char(s1),char(s2));                       %(4.48b)
id1'
id2'
[s1{1}(id1),s2{1}(id2)]
[xor,id1,id2] = setxor(char(s1),char(s2));                         %(4.48c)
id1'
id2'
sort([s1{1}(id1),s2{1}(id2)])
% Note: indexes might differ from the ones presented in the book, as they
% might point to different occurrences of the same characters, but the
% resulting sets of characters must be the same as the ones in the book.
pause;

disp('Example 4.49 -----------------------------------------------------');
[un,id2,id1] = union(char(s2),char(s1));                           %(4.49)
id1'
id2'
sort([s1{1}(id1),s2{1}(id2)])
pause;

disp('Example 4.50 -----------------------------------------------------');
setdiff(char(s1),char(s2))                                         %(4.50a)
ismember(char(s1),char(s2))                                        %(4.50b)
setdiff(char(s2),char(s1))                                         %(4.50c)
ismember(char(s2),char(s1))                                        %(4.50d)
pause;

disp('Example 4.51 -----------------------------------------------------');
unique(c1)                                                         %(4.51a)
unique(c2)                                                         %(4.51b)
union(c1,c2)                                                       %(4.51c)
intersect(c1,c2)                                                   %(4.51d)
setxor(c1,c2)                                                      %(4.51e)
setdiff(c1,c2)                                                     %(4.51f)
setdiff(c2,c1)                                                     %(4.51g)
ismember(c1,c2)                                                    %(4.51h)
ismember(c2,c1)                                                    %(4.51i)
pause;
